#include "header.h"

static map<key_build,bool(*)(term& x,map<char*,term*>& v),cmp_func<key_build> > inbuild;

static bool f_call(term& x,map<char*,term*>& v)
{
 bool b;
 if( x.v[0].var ) b = call(x.v[0], v);
 else 
 {
  if( v.count(x.v[0].name)==0 ){ return false;}
  b = call(*v[x.v[0].name], v);
 }
//      printf("v: "); print_v(v);  printf("\n");
 return b;
}

static bool f_fail(term& x,map<char*,term*>& v){ return false;}
static bool f_not(term& x,map<char*,term*>& v){ return !call(x.v[0],v);}
static bool f_nl(term& x,map<char*,term*>& v){ putchar('\n'); return true;}

static void print(term& a,map<char*,term*>& v)
{
 term* x = &a;
 
 while( v.count(x->name)==1 ) x = v[x->name];

 printf("%s",x->name);
 if( x->v.size()==0 ) return;
 printf("(");
 for(int i=0; i<x->v.size(); i++)
 {
  print(x->v[i],v);
  if( i+1 != x->v.size() ) printf(",");
 }
 printf(")");
}

bool f_write(term& a,map<char*,term*>& v)
{
 for(int i = 0; i<a.v.size(); i++) print(a.v[i],v);
 return true;
}

struct build { key_build key; bool(*func)(term&,map<char*,term*>&);};

static build in[] = {
		{{"call",1}, f_call},
		{{"fail",0}, f_fail},
		{{"not" ,1}, f_not },
		{{"nl"  ,0}, f_nl  },
		{{0     ,0}, NULL  }
};

void initial_inbuild()
{
 static int x = 0;
 
 if(x == 1) return;

 if(x == -1){ while(x == -1); return;}
 
 x = -1;
 
 printf("set_funcs\n");

 for(int i = 0; in[i].func; i++)
 {
  strings.insert(in[i].key.name);
  inbuild[in[i].key] = in[i].func;
 }
 
 x = 1;
}

bool inbuild_is(term& x)
{
  key_build key = {x.name,x.v.size()};
  return inbuild.count(key)==1;
}    

bool inbuild_call(term& x,map<char*,term*>& v)
{
 key_build key = {x.name,x.v.size()};
 return inbuild[key](x,v);
}
