#ifndef __HEADER_H__
#define __HEADER_H__

#include <stdio.h>
#include <stdlib.h>
#include <map>
#include <set>
#include <list>
#include <vector>
#include <stack>
#include <iostream>

using namespace std;

struct term
{
 char* name;
 int var;
 vector<term> v;
};

struct Vector { vector<term> v; bool isvar;};

#define err(FMT, ARG...)   (fprintf(stderr,"E: " FMT "\n", ## ARG ), WASERR = true)

// lex
extern char* yytext;
extern FILE* yyin, *yyout;
extern int yylineno;
extern int yynerrs;

int yylex();

// .y

template <class _Tp>
struct cmp_key : public binary_function<_Tp,_Tp,bool>
{
  bool operator()(const _Tp& __x, const _Tp& __y) const 
  { if(__x.name<__y.name) return true;
    if(__x.name == __y.name ) return __x.v.size()<__y.v.size();
    return false;
  }
};

template <class _Tp>
struct cmp : public binary_function<_Tp,_Tp,bool>
{
  bool operator()(const _Tp& __x, const _Tp& __y) const 
  { return strcmp(__x,__y)<0; }
};

template <class _Tp>
struct cmp_func : public binary_function<_Tp,_Tp,bool>
{
  bool operator()(const _Tp& __x, const _Tp& __y) const 
  { if(__x.name<__y.name) return true;
    if(__x.name == __y.name ) return __x.size<__y.size;
    return false;
  }
};

extern bool WASERR;
extern set<char*,cmp<char*> > strings;
extern multimap<term,vector<term>,cmp_key<term> > predicates;
extern map<char*,int> vars;
extern const char* All;

term* creatterm(char* s);
bool call(term& x,map<char*,term*>& v);
void printterm(term& x);
void print(term& x);
void print_v(map<char*,term*>& v);
void printpredicat(term& x,vector<term>& v);
void out(char* s,term& x);

// funcs.cc
struct key_build { char* name; int size;};

void initial_inbuild();
bool f_write(term& a,map<char*,term*>& v);
bool inbuild_call(term& x,map<char*,term*>& v);
bool inbuild_is(term& x);

#endif
