%{
#include "yacc.hpp"
#include <string.h>
#define err(FMT, ARG...)   fprintf(stderr,"%i: " FMT "\n", yylineno, ## ARG )
void strip(char* s)
{
 while( *s )
 {
  if( *s=='\'' ) memmove( s, s+1, strlen(s) );
  s++;
 }
}
%}
%option         yylineno
%x              in
A               [a-z][a-zA-Z_0-9]*
V               [A-Z_][a-zA-Z_0-9]*
U               \'([^\']|\'\')*\'
sim             ","|"."|"("|")"
S               [\ \n\t\v\f]
%%
{S}+            ;
"%"[^\n]*       ;
"/*"            BEGIN(in);
<in><<EOF>>     { err("end of file in comment (/*...*/)\n",""); BEGIN(INITIAL);}
<in>.           ;
<in>"*/"        BEGIN(INITIAL);
":-"|"<-"       return IF;
{A}             return ID;
{U}             { yytext++; yytext[strlen(yytext)-1] = '\0'; strip(yytext); return ID;}
{V}             return VAR;
{sim}           return *yytext;
<<EOF>>         return 0;
%%

int yywrap(){ return 1;}
